clear;
% [z,Fs]=audioread('Audio.wav');
% [z,Fs]=audioread('msg.wav');
% [z,Fs]=audioread('shake.wav');
% [z,Fs]=audioread('tweet.wav');
% [z,Fs]=audioread('Global.wav');
[z,Fs]=audioread('system.wav'); %读取语音信号的数据，赋给变量z
z1=randn(length(z),1);                       %产生与z长度一致的均匀分布随机信号

t=(0:(size(z)-1))/Fs; 
A=(min(abs(z))+max(abs(z)))*0.5;
z2=A*sin(2*pi*1000*t);         %加入正弦噪音

z4=z+z1+z2';                    %随机噪声合成
sound(z4);                                             %播放加噪声后的语音信号
% fs=22050;
% sound(x);

Wp_1=0.25*pi;
Ws_1=0.3*pi;
Wdelta_1=Ws_1-Wp_1;
N_1=ceil(6.6*pi/Wdelta_1);      %取整
Wn_1=[0.2 0.7]*pi/2;
b_1=fir1(N_1,Wn_1/pi,'stop',blackman(N_1+1));    %选择窗函数，并归一化截止频率

figure(1);
freqz(b_1,1,1024);
f2=filter(b_1,1,z4);
sound(f2);                                              %播放滤波后的语音信号
figure(2);
subplot(2,1,1);
plot(t,z4);
set(gca,'Fontsize',22);
title('滤波前加噪声的语音信号时域波形图','Fontsize',22);
xlabel('时间（s）','Fontsize',22);
ylabel('幅值','Fontsize',22);
subplot(2,1,2);
plot(t,f2);  
set(gca,'Fontsize',22);
title('滤波后的语音信号时域波形图','Fontsize',22);
xlabel('时间（s）','Fontsize',22);
ylabel('幅值','Fontsize',22);
figure(3);
f=Fs*(0:1023)/2048;
y2=fft(z4,2048);
subplot(2,1,1);
plot(f,abs(y2(1:1024)));                  %画出滤波前的频谱图
set(gca,'Fontsize',22);
title('滤波前加噪声的语音信号的频谱','Fontsize',22)
xlabel('频率','Fontsize',22);
ylabel('幅值','Fontsize',22);
F0=fft(f2,2048);
subplot(2,1,2);
plot(f,abs(F0(1:1024)));              %画出滤波后的频谱图
set(gca,'Fontsize',22);
title('滤波后的语音信号的频谱','Fontsize',22);   
xlabel('频率','Fontsize',22);
ylabel('幅值','Fontsize',22);
